//+------------------------------------------------------------------+
//|                                             Pearson Pivot EA.mq4 |
//|                                                      Elitecamper |
//|                                                                  |
//+------------------------------------------------------------------+

// External variables
extern double LotSize = 0.1;
extern double StopLoss = 100;
extern double TakeProfit = 40;
extern int NumPips=10;
extern int Slippage = 5;
extern int Magic = 123;

extern double TrailingStop = 35;
extern bool trail = false;

// Global variables
int BuyTicket;
int SellTicket;
double UsePoint;
int UseSlippage;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
	{
      UsePoint = PipPoint(Symbol());
      UseSlippage = GetSlippage(Symbol(),Slippage);
	}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
	{
	
	if (trail) trail();
	
	int Total=0;

for(int i=0;i<OrdersTotal();i++)
{
OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
Total++;
}
	
		// Support and resistance 
  double dp = iCustom(NULL,0,"Pivot points plus 1.01 EA test",0,0);
  double s1 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",1,0);
  double r1 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",2,0);
  double s2 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",3,0);
  double r2 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",4,0);
  double s3 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",5,0);
  double r3 = iCustom(NULL,0,"Pivot points plus 1.01 EA test",6,0);
  
  double stochk=iStochastic(NULL,0,14,3,3,0,0,0,1);	
  double stochk1=iStochastic(NULL,0,14,3,3,0,0,0,2);
  double stochd=iStochastic(NULL,0,14,3,3,0,0,1,1);	
  double stochd1=iStochastic(NULL,0,14,3,3,0,0,1,2);	
	
		// Buy order 
		if (Low[0] < (s1 + (NumPips * 0.0001)) && Low[0] > (s1 - (NumPips * 0.0001)) ||
		    Low[0] < (s2 + (NumPips * 0.0001)) && Low[0] > (s2 - (NumPips * 0.0001)) ||
		    Low[0] < (s3 + (NumPips * 0.0001)) && Low[0] > (s3 - (NumPips * 0.0001)) && stochk1 <= 22 && stochk > 22 && stochd1 <= 22 && stochd > 22 && Total < 1)
          
			{
				OrderSelect(SellTicket,SELECT_BY_TICKET);
		
				// Close order
				if(OrderCloseTime() == 0 && SellTicket > 0)
					{
						double CloseLots = OrderLots();
						double ClosePrice = Ask;

						bool Closed = OrderClose(SellTicket,CloseLots,ClosePrice,UseSlippage,Red);
					}				

				double OpenPrice = Ask;
				
				// Calculate stop loss and take profit
				if(StopLoss > 0) double BuyStopLoss = OpenPrice - (StopLoss * UsePoint);
				if(TakeProfit > 0) double BuyTakeProfit = OpenPrice + (TakeProfit * UsePoint);
				
				// Open buy order
				BuyTicket = OrderSend(Symbol(),OP_BUY,LotSize,OpenPrice,UseSlippage,BuyStopLoss,BuyTakeProfit,"Buy Order",Magic,0,Green);
				
				SellTicket = 0;
			}
		
		
		// Sell Order 
		if (High[0] > (r1 - (NumPips * 0.0001)) && High[0] < (r1 + (NumPips * 0.0001)) ||
		    High[0] > (r2 - (NumPips * 0.0001)) && High[0] < (r2 + (NumPips * 0.0001)) || 
		    High[0] > (r3 - (NumPips * 0.0001)) && High[0] < (r3 + (NumPips * 0.0001)) && stochk1 >= 72 && stochk < 72 && stochd1 >= 72 && stochd < 72 && Total < 1)
         
			{
				OrderSelect(BuyTicket,SELECT_BY_TICKET);
		
				if(OrderCloseTime() == 0 && BuyTicket > 0)
					{
						CloseLots = OrderLots();
						ClosePrice = Bid;

						Closed = OrderClose(BuyTicket,CloseLots,ClosePrice,UseSlippage,Red);
					}		
				
				OpenPrice = Bid;
				
				if(StopLoss > 0) double SellStopLoss = OpenPrice + (StopLoss * UsePoint);
				if(TakeProfit > 0) double SellTakeProfit = OpenPrice - (TakeProfit *	UsePoint);
				
				SellTicket = OrderSend(Symbol(),OP_SELL,LotSize,OpenPrice,UseSlippage,SellStopLoss,SellTakeProfit,"Sell Order",Magic,0,Red);
				
				BuyTicket = 0;
			}
			
		return(0);
	}


// Pip Point Function
double PipPoint(string Currency)
	{
		int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
		if(CalcDigits == 2 || CalcDigits == 3) double CalcPoint = 0.01;
		else if(CalcDigits == 4 || CalcDigits == 5) CalcPoint = 0.0001;
		return(CalcPoint);
	}


// Get Slippage Function
int GetSlippage(string Currency, int SlippagePips)
	{
		int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
		if(CalcDigits == 2 || CalcDigits == 4) double CalcSlippage = SlippagePips;
		else if(CalcDigits == 3 || CalcDigits == 5) CalcSlippage = SlippagePips * 10;
		return(CalcSlippage);
	}


void trail() 
{
for (int i = 0; i < OrdersTotal(); i++) 

{
OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

if ( OrderSymbol()==Symbol() ) 
{
if (OrderType() == OP_BUY) 
{
if (Bid - OrderOpenPrice() > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) 
{
if (OrderStopLoss() < Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) 
{
OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red);
}
}

} else if (OrderType() == OP_SELL) 
{
if (OrderOpenPrice() - Ask > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) 
{
if ((OrderStopLoss() > Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) || 
(OrderStopLoss() == 0)) 
{
OrderModify(OrderTicket(), OrderOpenPrice(),
Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red); 
}
}
}
}
}
}



